<?php
	ob_start();

	require 'config.php';
	require 'common.php';

	# Image Vomitorium 1.1 by Tyler Bletsch (tkbletsc (at) eml.cc)
	#  http://dsss.be/image-vomitorium/
	
	# This is free software; use at your own risk.  Author accepts no 
	# responsibility for the quality of this product.  Feel free to modify or 
	# distribute this code without restriction.

function handleUpload() {
	global $maxFileSize, $dataDir, $thumbDir, $thumbnailDim, $thumbnailMethod, $convertCmd, $allowedExtensions;
	
	# Base URL
	$urlbase = getUrlBase();
	
	if (!isset($_FILES['img']) || !$_FILES['img'] || !$_FILES['img']['name']) { 
		header("Location: $urlbase");
		exit;
	}

	# get basename and clean it of dangerous characters
	$basename = basename($_FILES['img']['name']);
	$basename = preg_replace("/[\\\"\`\~\+\|\:\;\[\]\{\}\<\>\,\?\']/",'-',$basename);
	
	# Get basename and extension; validate extension
	if (preg_match("/(.*)(\..*)$/",$basename, $matches)) {
		$filenameBase=$matches[1]; $extension=$matches[2];
		$bOkay=0;
		foreach ($allowedExtensions as $ext) {
			if (strcasecmp(".$ext",$extension)==0) { $bOkay=1; }
		}
		if (!$bOkay) { 
			complain("File extension '$extension' not in set of allowed extensions (".join(',',$allowedExtensions).")."); return;
		}
	} else {
		complain("Filename '$basename' lacks an extension"); return;
	}
	
	# Find a free filename based on given name
	$filename = $dataDir . $basename;
	$thumbnail = $thumbDir . $basename;
	
	$i=0;	
	while (file_exists($filename) || file_exists($thumbnail)) {
		$i++;
		$basename = "$filenameBase$i$extension";
		$filename = "$dataDir$basename";
		$thumbnail = "$thumbDir$basename";
	}

	# URLs to the file and its thumbnail
	#$fileurl = $urlbase . $filename;
	#$thumburl = $urlbase . $thumbnail;
	$urlView = str_replace(" ","%20","${urlbase}view.php?i=$basename");

	# Move temp file to destination
	if (move_uploaded_file($_FILES['img']['tmp_name'], $filename)) {
		if ($thumbnailMethod == 'gd') {
			print "createthumb_gd($filename,$thumbnail,$thumbnailDim,$thumbnailDim);<BR>\n";
			createthumb_gd($filename,$thumbnail,$thumbnailDim,$thumbnailDim);
		} elseif ($thumbnailMethod == 'command') {
			system("$convertCmd \"".addslashes($filename)."\" \"".addslashes($thumbnail)."\"");
		} else {
			complain("Settings error: Unrecognized thumbnailMethod '$thumbnailMethod'");
		}
		
		header("Location: $urlView"); # Redirect browser
		#print "<a href='$urlView'>$urlView</a><BR>"; # Redirect browser
		exit;

	} else {
		echo "Possible file upload attack! \n";
	}
	

}

/**
 * Creates a thumbnail image.  
 * Adapted from http://icant.co.uk/articles/phpthumbnails/
 * 
 * Parameters:
 *  $src  - Original filename
 *  $dest - Filename of the resized image
 *  $maxW - width of resized image
 *  $maxH - height of resized image
*/	
function createthumb_gd($src,$dest,$maxW,$maxH) {
	if (preg_match("/(\.jpg|\.jpeg)$/i",$src)) {$src_img=imagecreatefromjpeg($src) or print "Error reading JPG";}
	elseif (preg_match("/\.png$/i",$src))      {$src_img=imagecreatefrompng($src) or print "Error reading JPG";}
	elseif (preg_match("/\.gif$/i",$src))      {$src_img=imagecreatefromgif($src) or print "Error reading JPG";}
	else { print "Unable to create thumbnail - unsupported format!<br>\n"; return; }
	
	$old_x=imageSX($src_img);
	$old_y=imageSY($src_img);
	
	if ($old_x > $old_y) {
		$thumb_w=$maxW;
		$thumb_h=$old_y*($maxH/$old_x);
	} elseif ($old_x < $old_y) {
		$thumb_w=$old_x*($maxW/$old_y);
		$thumb_h=$maxH;
	} else { # ($old_x == $old_y)
		$thumb_w=$maxW;
		$thumb_h=$maxH;
	}
	
	$dst_img=ImageCreateTrueColor($thumb_w,$thumb_h);
	imagecopyresampled($dst_img,$src_img,0,0,0,0,$thumb_w,$thumb_h,$old_x,$old_y); 
	
	// Create image and define colors
	$colorBlack=imagecolorallocate($dst_img, 0, 0, 0);

	// Create border around image
	imageline($dst_img, 0, 0, 0, $thumb_h, $colorBlack);
	imageline($dst_img, 0, 0, $thumb_w, 0, $colorBlack);
	imageline($dst_img, $thumb_w-1, 0, $thumb_w-1, $thumb_h-1, $colorBlack);
	imageline($dst_img, 0, $thumb_h-1, $thumb_w-1, $thumb_h-1, $colorBlack);

	if (preg_match("/(\.jpg|\.jpeg)$/i",$src)) {imagejpeg($dst_img,$dest) or print "Error writing thumbnail JPG";}
	elseif (preg_match("/\.png$/i",$src))      {imagepng($dst_img,$dest) or print "Error writing thumbnail PNG";;}
	elseif (preg_match("/\.gif$/i",$src))      {imagegif($dst_img,$dest) or print "Error writing thumbnail GIF";;}
	
	print "'$dest' ? exist == ".file_exists($dest) ;

	imagedestroy($dst_img); 
	imagedestroy($src_img); 
}

function complain ($reason) {
	print "<hr><h1 align=center>Invalid upload</h1><H2 align=center>$reason</h2><hr>";
}

handleUpload(); 

?>